/**
 *
 * Written by Ed Hong UWT Feb. 19, 2003
 *
 * @author edhong
 * @version 0.0
 */

 import java.util.*;

/** This class specializes DFS to print out vertices and edges on a dfs
  * traversal of G. Vertices and edges are printed out when they are first
  * visited.
  */
public class DFSPrint extends DFS {

  /** returns list of Vertices representing path
      that was constructed in DFS traversal */
  public  void printDFS(SimpleGraph G, Vertex start) {
	  // initialize things.

	  // do the dfs
	  execute(G,start);

	  // return result
  }

  protected void startVisit(Vertex v) {
	System.out.println(" Vertex["+ v.element() + "]");
  }
  protected void traverseDiscovery(Edge e, Vertex v) {
	System.out.print("   Discovery Edge[" + e.element()+"]");
	System.out.print(" going from Vertex[" + v.element() + "]");
	System.out.println(" to Vertex[" + G.opposite(v,e).element() + "]");
  }
  protected void traverseBack(Edge e, Vertex v) {
	System.out.print("   Back Edge[" + e.element()+"]");
	System.out.print(" going from Vertex[" + v.element() + "]");
	System.out.println(" to Vertex[" + G.opposite(v,e).element() + "]"); 
  }
}
